Index: codes/icosagcm/devel/src/dcmip/dcmip_initial_conditions_test_1_2_3_v5.f90
===================================================================
--- codes/icosagcm/devel/src/dcmip/dcmip_initial_conditions_test_1_2_3_v5.f90	(revision 976)
+++ codes/icosagcm/devel/src/dcmip/dcmip_initial_conditions_test_1_2_3_v5.f90	(revision 995)
@@ -874,5 +874,5 @@
 ! Test 2-0:  Steady-State Atmosphere at Rest in the Presence of Orography
 !=========================================================================
-SUBROUTINE test2_steady_state_mountain (lon,lat,p,z,zcoords,hybrid_eta,hyam,hybm,u,v,w,t,phis,ps,rho,q)
+SUBROUTINE test2_steady_state_mountain (lon,lat,p,z,zcoords,hybrid_eta,hyam,hybm,u,v,w,t,phis,ps,rho,q,h0_test2)
 
 IMPLICIT NONE
@@ -922,5 +922,4 @@
                             	lambdam = 3.d0*pi/2.d0,		&	! mountain longitude center point (radians)   
                             	phim    = 0.d0,			&	! mountain latitude center point (radians)    
-                            	h0      = 2000.d0,		&	! peak height of the mountain range (m)
                             	Rm      = 3.d0*pi/4.d0,		&	! mountain radius (radians)
                             	zetam   = pi/16.d0,		&	! mountain oscillation half-width (radians) 
@@ -930,7 +929,14 @@
       real(rstd) :: r							! Great circle distance (radians)
       real(rstd) :: zs							! Surface elevation (m)
-      real(rstd) :: exponent                                               ! exponent: g/(Rd * gamma)
-      real(rstd) :: exponent_rev                                           ! reversed exponent
-
+      real(rstd) :: exponent                                            ! exponent: g/(Rd * gamma)
+      real(rstd) :: exponent_rev                                        ! reversed exponent
+      real(rstd) :: h0                                                  ! peak height of the mountain range (m)
+      real(rstd), optional :: h0_test2
+
+      if (present(h0_test2)) then 
+         h0 = h0_test2       ! peak height of the mountain range (m), can be modified in run.def 
+      else
+         h0 = 250.d0         ! Default value for call without optional variable h0_test2
+      endif
 
 !-----------------------------------------------------------------------
@@ -1025,6 +1031,6 @@
 !=====================================================================================
 
-SUBROUTINE test2_schaer_mountain (lon,lat,p,z,zcoords,hybrid_eta,hyam,hybm,shear,u,v,w,t,phis,ps,rho,q)
-USE getin_mod, ONLY : getin
+SUBROUTINE test2_schaer_mountain (lon,lat,p,z,zcoords,hybrid_eta,hyam,hybm,shear,u,v,w,t,phis,ps,rho,q,h0_test2,Teq_test2)
+
 IMPLICIT NONE
 !-----------------------------------------------------------------------
@@ -1078,5 +1084,4 @@
 				lambdac = pi/4.d0, 		& 	! Lon of Schar Mountain Center
 				phic    = 0.d0,	 		& 	! Lat of Schar Mountain Center
-				h0      = 250.d0, 		& 	! Height of Mountain
 				d       = 5000.d0, 		& 	! Mountain Half-Width
 				xi      = 4000.d0, 		& 	! Mountain Wavelength
@@ -1088,8 +1093,18 @@
       real(rstd) :: zs							! Surface height
       real(rstd) :: c							! Shear
-
-      REAL(rstd) :: Teq                 = 300.d0   ! default Temperature at Equator, can be modified in run.def
-
-      CALL getin("dcmip2_Teq",Teq)
+      real(rstd) :: h0                                                  ! peak height of the mountain range (m)
+      real(rstd) :: Teq                                                 ! Temperature at Equator    
+      real(rstd), optional :: h0_test2,Teq_test2 ! FIX default value in MODULE etat0_dcmip2_mod
+
+      if (present(h0_test2)) then
+         h0 = h0_test2           ! peak height of the mountain range (m), can be modified in run.def
+      else
+         h0 = 250.d0             ! Default value for call without optional variable h0_test2
+      endif
+      if (present(Teq_test2)) then
+         Teq = Teq_test2         ! Temperature at Equator, can be modified in run.def
+      else
+         Teq = 300.d0            ! Default value for call without optional variable Teq_test2
+      endif
 !-----------------------------------------------------------------------
 !    PHIS (surface geopotential)
@@ -1199,5 +1214,5 @@
 !==========
 SUBROUTINE test3_gravity_wave (X,lon,lat,p,z,zcoords,u,v,w,t,phis,ps,rho,q)
-USE getin_mod, ONLY : getin
+
 IMPLICIT NONE
 !-----------------------------------------------------------------------
@@ -1234,4 +1249,5 @@
 			    	u0      = 20.d0,		&	! Reference Velocity 
 !			    	u0      = 0.d0,		        &	! FIXME : no zonal wind for NH tests
+                            	Teq     = 300.d0,		&	! Temperature at Equator    
 			    	Peq     = 100000.d0,		&	! Reference PS at Equator
                             	ztop    = 10000.d0,		&	! Model Top       
@@ -1254,8 +1270,4 @@
       real(rstd) :: theta_pert						! Pot-temp perturbation
 
-      REAL(rstd) :: Teq                 = 300.d0   ! default Temperature at Equator, can be modified in run.def
-
-      CALL getin("dcmip2_Teq",Teq)
-
       as = a/X
 