Index: /codes/icosagcm/devel/src/dcmip/dcmip2016_kessler_physic.f90
===================================================================
--- /codes/icosagcm/devel/src/dcmip/dcmip2016_kessler_physic.f90	(revision 1025)
+++ /codes/icosagcm/devel/src/dcmip/dcmip2016_kessler_physic.f90	(revision 1026)
@@ -74,4 +74,6 @@
   !------------------------------------------------
 
+  INTEGER, INTENT(IN) :: nz ! Number of thermodynamic levels in the column
+
   REAL(8), DIMENSION(nz), INTENT(INOUT) :: &
             theta   ,     & ! Potential temperature (K)
@@ -92,6 +94,4 @@
   REAL(8), INTENT(IN) :: & 
             dt              ! Time step (s)
-
-  INTEGER, INTENT(IN) :: nz ! Number of thermodynamic levels in the column
 
   !------------------------------------------------
Index: /codes/icosagcm/devel/src/dissip/nudging_mod.f90
===================================================================
--- /codes/icosagcm/devel/src/dissip/nudging_mod.f90	(revision 1025)
+++ /codes/icosagcm/devel/src/dissip/nudging_mod.f90	(revision 1026)
@@ -15,8 +15,9 @@
        nudging_relaxation_time_in,nudging_relaxation_time_out
   !$OMP THREADPRIVATE(center_lon, center_lat, nudging_radius, nudging_relaxation_time,nudging_relaxation_time_in,nudging_relaxation_time_out)
+
   TYPE(t_field),POINTER :: f_relax_coef_e(:), f_target_ue(:), &
        f_relax_coef_i(:), f_target_theta_rhodz(:),f_target_ps(:)
-  CHARACTER(LEN=255),SAVE :: guided_nudging_field
-  INTEGER,SAVE :: nudging_time
+  CHARACTER(LEN=255) :: guided_nudging_field
+  INTEGER :: nudging_time
 
   PUBLIC :: init_guided, guided
Index: /codes/icosagcm/devel/src/dynamics/compute_NH_geopot.F90
===================================================================
--- /codes/icosagcm/devel/src/dynamics/compute_NH_geopot.F90	(revision 1025)
+++ /codes/icosagcm/devel/src/dynamics/compute_NH_geopot.F90	(revision 1026)
@@ -228,5 +228,5 @@
     tau2_g=tau*tau/g
     g2=g*g
-    gm2 = g**-2
+    gm2 = g**(-2)
     gamma = 1./(1.-kappa)
     
Index: /codes/icosagcm/devel/src/initial/etat0_heldsz.f90
===================================================================
--- /codes/icosagcm/devel/src/initial/etat0_heldsz.f90	(revision 1025)
+++ /codes/icosagcm/devel/src/initial/etat0_heldsz.f90	(revision 1026)
@@ -8,13 +8,13 @@
   TYPE(t_field),POINTER :: f_theta(:)
 
-  REAL(rstd),ALLOCATABLE,SAVE :: knewt_t(:),kfrict(:)
+  REAL(rstd),ALLOCATABLE :: knewt_t(:),kfrict(:)
 !$OMP THREADPRIVATE(knewt_t,kfrict)
-  LOGICAL, SAVE :: done=.FALSE.
+  LOGICAL :: done=.FALSE.
 !$OMP THREADPRIVATE(done)
 
-  REAL(rstd),SAVE :: p0,teta0,ttp,delt_y,delt_z,eps
+  REAL(rstd) :: p0,teta0,ttp,delt_y,delt_z,eps
 !$OMP THREADPRIVATE(p0,teta0,ttp,delt_y,delt_z,eps)
 
-  REAL(rstd),SAVE :: knewt_g, k_f,k_c_a,k_c_s
+  REAL(rstd) :: knewt_g, k_f,k_c_a,k_c_s
 !$OMP THREADPRIVATE(knewt_g, k_f,k_c_a,k_c_s)
 
Index: /codes/icosagcm/devel/src/output/output_field.f90
===================================================================
--- /codes/icosagcm/devel/src/output/output_field.f90	(revision 1025)
+++ /codes/icosagcm/devel/src/output/output_field.f90	(revision 1026)
@@ -7,7 +7,7 @@
   PRIVATE
 
-  LOGICAL,SAVE :: xios_output 
+  LOGICAL :: xios_output 
 !$OMP THREADPRIVATE(xios_output)     
-  LOGICAL,SAVE :: enable_io    
+  LOGICAL :: enable_io    
 !$OMP THREADPRIVATE(enable_io)     
 
Index: /codes/icosagcm/devel/src/output/xios_mod.F90
===================================================================
--- /codes/icosagcm/devel/src/output/xios_mod.F90	(revision 1025)
+++ /codes/icosagcm/devel/src/output/xios_mod.F90	(revision 1026)
@@ -25,9 +25,10 @@
 #ifdef CPP_USING_XIOS
 
-  PUBLIC :: xios_timestep,    & 
+  PUBLIC :: xios_timestep,    &
        xios_set_file_attr, xios_set_fieldgroup_attr, &
        xios_set_filegroup_attr, xios_get_axis_attr, &
        xios_send_field, xios_read_var, &
-       xios_update_calendar, xios_set_context, xios_set_context_input
+       xios_update_calendar, xios_set_context, xios_set_context_input, &
+       OPERATOR(+), OPERATOR(-), OPERATOR(*)
   
 CONTAINS
Index: /codes/icosagcm/devel/src/parallel/transfert_mpi.f90
===================================================================
--- /codes/icosagcm/devel/src/parallel/transfert_mpi.f90	(revision 1025)
+++ /codes/icosagcm/devel/src/parallel/transfert_mpi.f90	(revision 1026)
@@ -2159,6 +2159,6 @@
     IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: nb
     INTEGER,DIMENSION(nb),INTENT(INOUT) :: Var
-    INTEGER,INTENT(IN) :: nb
 
     IF (.NOT. using_mpi) RETURN
@@ -2176,6 +2176,6 @@
     IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: nb
     REAL,DIMENSION(nb),INTENT(INOUT) :: Var
-    INTEGER,INTENT(IN) :: nb
 
     IF (.NOT. using_mpi) RETURN
@@ -2193,6 +2193,6 @@
     IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: nb
     LOGICAL,DIMENSION(nb),INTENT(INOUT) :: Var
-    INTEGER,INTENT(IN) :: nb
 
     IF (.NOT. using_mpi) RETURN
Index: /codes/icosagcm/devel/src/parallel/transfert_omp.f90
===================================================================
--- /codes/icosagcm/devel/src/parallel/transfert_omp.f90	(revision 1025)
+++ /codes/icosagcm/devel/src/parallel/transfert_omp.f90	(revision 1026)
@@ -804,8 +804,7 @@
   SUBROUTINE bcast_omp_cgen(Var,Nb,Buff)
   IMPLICIT NONE
-    
+    INTEGER,INTENT(IN) :: Nb
     CHARACTER(LEN=*),INTENT(INOUT) :: Var
     CHARACTER(LEN=*),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
     
     INTEGER :: i
@@ -824,11 +823,10 @@
 
 
-      
+
   SUBROUTINE bcast_omp_igen(Var,Nb,Buff)
   IMPLICIT NONE
-    
+    INTEGER,INTENT(IN) :: Nb
     INTEGER,DIMENSION(Nb),INTENT(INOUT) :: Var
     INTEGER,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
 
     INTEGER :: i
@@ -851,8 +849,7 @@
   SUBROUTINE bcast_omp_rgen(Var,Nb,Buff)
   IMPLICIT NONE
-    
+    INTEGER,INTENT(IN) :: Nb
     REAL,DIMENSION(Nb),INTENT(INOUT) :: Var
     REAL,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
 
     INTEGER :: i
@@ -874,8 +871,7 @@
   SUBROUTINE bcast_omp_lgen(Var,Nb,Buff)
   IMPLICIT NONE
-    
+    INTEGER,INTENT(IN) :: Nb
     LOGICAL,DIMENSION(Nb),INTENT(INOUT) :: Var
     LOGICAL,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
   
     INTEGER :: i
Index: /codes/icosagcm/devel/src/physics/physics.f90
===================================================================
--- /codes/icosagcm/devel/src/physics/physics.f90	(revision 1025)
+++ /codes/icosagcm/devel/src/physics/physics.f90	(revision 1026)
@@ -106,5 +106,5 @@
 !$OMP END PARALLEL
 
-    IF(done==.FALSE.) THEN
+    IF(.NOT. done) THEN
        SELECT CASE(phys_type)
        CASE(phys_external) 
Index: /codes/icosagcm/devel/src/sphere/compute_geometry.f90
===================================================================
--- /codes/icosagcm/devel/src/sphere/compute_geometry.f90	(revision 1025)
+++ /codes/icosagcm/devel/src/sphere/compute_geometry.f90	(revision 1026)
@@ -9,8 +9,6 @@
   USE transfert_mod, ONLY : req_i0, req_i1, t_message, transfert_request, transfert_message, init_message
 
-  USE spherical_geom_mod, ONLY : xyz2lonlat, circumcenter, &
-       compute_centroid, centroid, &
-       surf_triangle, dist_cart, div_arc_bis, &
-       schmidt_transform
+  USE spherical_geom_mod, ONLY : xyz2lonlat, circumcenter, compute_centroid, &
+       surf_triangle, dist_cart, div_arc_bis, schmidt_transform
   USE vector, ONLY : norm, cross_product2
 
Index: /codes/icosagcm/devel/src/time/hevi_scheme.f90
===================================================================
--- /codes/icosagcm/devel/src/time/hevi_scheme.f90	(revision 1025)
+++ /codes/icosagcm/devel/src/time/hevi_scheme.f90	(revision 1026)
@@ -37,5 +37,5 @@
     ! Euler scheme disguised as ARK for development purposes
     REAL(rstd) :: dt
-    CALL set_coefs_rk(dt, (/ zero, (/1.,0.,0./), (/0.,0.,0./), (/0./0.,0./0.,0./) /) )
+    CALL set_coefs_rk(dt, (/ zero, (/1.,0.,0./), (/0.,0.,0./), (/0.,0.,0./) /) )
   END SUBROUTINE set_coefs_ark11
     